<!--version: 2, 设备选择弹窗-->

<template>
  <el-dialog :title="title" :visible="show" width="1000px" top="2vh" @open="open" @close="close"
             :append-to-body="true">
    <el-form size="small" :inline="true" label-width="5em" @submit.prevent.native="onSearch">
      <el-form-item label="设备SN">
        <el-input v-model="searchForm.deviceNo" clearable placeholder="请输入设备SN" @keyup.enter.native="onSearch"></el-input>
      </el-form-item>
      <el-form-item label="设备MAC" label-width="6em">
        <el-input v-model="searchForm.mac" clearable placeholder="请输入设备MAC" @keyup.enter.native="onSearch"></el-input>
      </el-form-item>
      <el-form-item label="设备名称">
        <el-input v-model="searchForm.deviceName" clearable placeholder="请输入设备名称" @keyup.enter.native="onSearch"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="onSearch()" icon="el-icon-search">搜索</el-button>
      </el-form-item>
    </el-form>

    <el-row v-if="multiple" style="margin-bottom: 1em;">
      <span style="line-height: 28px">已选：</span>
      <span style="line-height: 28px" v-if="selected == null || selected.length === 0">暂无</span>
      <el-tag
        v-for="(item,index) of selected"
        type="primary"
        closable
        disable-transitions
        style="margin-right: 4px"
        @close="onCloseSelected(index)"
      >{{item.deviceName}}({{item.deviceNo}})</el-tag>
    </el-row>

    <el-table
      ref="multipleTable"
      :data="tableData"
      v-loading="loadTable"
      @row-click="changeSelection"
      @row-dblclick="select"
      @select-all="selectionAll"
      @select="changeSelection"
      highlight-current-row
    >
      <el-table-column align="center" type="selection" v-if="multiple"></el-table-column>
      <el-table-column label="#" type="index" align="center" width="80"></el-table-column>
      <el-table-column label="设备名称" align="center" prop="deviceName"></el-table-column>
      <el-table-column label="设备MAC" align="center" prop="mac"></el-table-column>
      <el-table-column label="设备SN" align="center" prop="deviceNo"></el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime"></el-table-column>
    </el-table>
    <pagination
      :limit.sync="searchForm.pageSize"
      :page.sync="searchForm.pageNum"
      :total="total"
      @pagination="searchList">
    </pagination>
    <template #footer>
      <el-button type="primary" @click="submit()">确定</el-button>
    </template>
  </el-dialog>
</template>

<script>
import {clone} from "@/utils";
import { listDevice } from '@/api/system/device'
import { mapGetters } from 'vuex'
import { UserType } from '@/utils/constants'
import { mchListDevice } from '@/api/mch/device'

export default {
  name: "DeviceDialog",
  props: {
    // 标题
    title: {
      type: String,
      default: '选择设备'
    },
    value: {
      type: [String, Number, Array],
      default: null,
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    show: {
      type: Boolean,
      default: false
    },
    query: {
      type: Object,
      default: () => ({})
    },
    initSelect: {
      type: Array,
      default: null,
    }
  },
  data() {
    return {
      loadTable: false,
      tableData: [],
      searchForm: {},
      total: 0,
      row: null,
      selected: [],
    }
  },
  computed: {
    ...mapGetters(['userType'])
  },
  methods: {
    onCloseSelected(index) {
      this.selected.splice(index, 1);
      this.$nextTick(() => {
        this.refreshTableSelection();
      })
    },
    // 获取数据列表
    searchList() {
      this.loadTable = true;
      if (this.userType === UserType.APP) {
        mchListDevice(this.searchForm).then(response => {
          this.tableData = response.rows;
          this.total = response.total;
          // 刷新表格状态
          this.$nextTick(()=>{
            this.refreshTableSelection();
          })
        }).finally(() =>{
          this.loadTable = false;
        })
      } else {
        listDevice(this.searchForm).then(response => {
          this.tableData = response.rows;
          this.total = response.total;
          // 刷新表格状态
          this.$nextTick(()=>{
            this.refreshTableSelection();
          })
        }).finally(() =>{
          this.loadTable = false;
        })
      }
    },
    // 打开时
    open() {
      this.searchForm = {
        pageNum: 1,
        pageSize: 10,
        ...this.query,
      }

      if (this.initSelect) {
        this.selected = clone(this.initSelect);
      } else {
        this.selected = [];
      }

      this.searchList();
    },
    // 刷新表格的选中状态
    refreshTableSelection() {
      if(this.multiple){
        this.tableData.forEach(item => {
          if (this.selected.map(j => j.deviceId).includes(item.deviceId)) {
            this.$refs.multipleTable.toggleRowSelection(item, true);
          } else {
            this.$refs.multipleTable.toggleRowSelection(item, false);
          }
        });
      }
    },
    // 全选
    selectionAll(val){
      let flag = val.length > 0;
      this.tableData.forEach(item => {
        if (flag && !this.selected.map(i => i.deviceId).includes(item.deviceId)){
          this.selected.push(item);
        } else if (!flag && this.selected.map(i => i.deviceId).includes(item.deviceId)){
          this.selected = this.selected.filter(i => i.deviceId !== item.deviceId);
        }
      })
    },
    // 确认选中
    submit() {
      if (this.multiple) {
        this.$emit('select', this.selected);
      } else {
        this.select(this.row);
      }
    },
    // 更换某一行的选中状态
    changeSelection(row){
      console.log(this.multiple);
      if(this.multiple){
        if (this.selected.map(i => i.deviceId).includes(row.deviceId)){
          this.$refs.multipleTable.toggleRowSelection(row, false);
          this.selected = this.selected.filter(i => i.deviceId !== row.deviceId);
        }else {
          this.$refs.multipleTable.toggleRowSelection(row, true);
          this.selected.push(row);
        }
      } else {
        this.row = row;
      }
    },
    // 点击搜索
    onSearch() {
      this.searchForm.pageNum = 1;
      this.searchList();
    },
    // 关闭弹窗
    close() {
      this.$emit('update:show', false);
      this.searchForm.pageNum = 1;
      this.searchForm.pageSize = 10;
    },
    // 选中一行
    select(row) {
      if (!this.multiple) {
        if (!row) return this.$message.error('请选择一行');
        this.selected = [row];
        this.$emit('select', row);
      }
    },
  },
}
</script>
